Problem A. Ascending Rating hdu 6319 单调栈

Problem Description

Before the start of contest, there are n ICPC contestants waiting in a long queue. They are labeled by 1 to n from left to right. It can be easily found that the i-th contestant's QodeForces rating is ai.
Little Q, the coach of Quailty Normal University, is bored to just watch them waiting in the queue. He starts to compare the rating of the contestants. He will pick a continous interval with length m, say [l,l+m−1], and then inspect each contestant from left to right. Initially, he will write down two numbers maxrating=−1 and count=0. Everytime he meets a contestant k with strictly higher rating than maxrating, he will change maxrating to ak and count to count+1.
Little T is also a coach waiting for the contest. He knows Little Q is not good at counting, so he is wondering what are the correct final value of maxrating and count. Please write a program to figure out the answer.

Input

The first line of the input contains an integer T(1≤T≤2000), denoting the number of test cases.
In each test case, there are 7 integers n,m,k,p,q,r,MOD(1≤m,k≤n≤107,5≤p,q,r,MOD≤109) in the first line, denoting the number of contestants, the length of interval, and the parameters k,p,q,r,MOD.
In the next line, there are k integers a1,a2,...,ak(0≤ai≤109), denoting the rating of the first k contestants.
To reduce the large input, we will use the following generator. The numbers p,q,r and MOD are given initially. The values ai(k<i≤n) are then produced as follows :

ai=(p×ai−1+q×i+r)modMOD


It is guaranteed that ∑n≤7×107 and ∑k≤2×106.

Output

Since the output file may be very large, let's denote maxratingi and counti as the result of interval [i,i+m−1].
For each test case, you need to print a single line containing two integers A and B, where :


Note that ``⊕'' denotes binary XOR operation.

Sample Input

 

1

10 6 10 5 5 5 5

3 2 2 1 5 7 6 8 2 9

Sample Output

 

46 11

题意  t组样例,

第一行为n,m,k,p,q,r,MOD,第二行为 a1至ak的数列 ,a(k+!)至an符合一个公式ai=(p×ai−1+q×i+r)modMOD

i从1到(n-m+1),为从序列i开始长度为m的序列,max为此序列的最大值,count为这个序列以第一个元素严格递增,有几个元素。

求A B 的值

单调栈
从后面往前进行单调栈。  注意初始化的问题。

#include<map>
#include<set>
#include<queue>
#include<stack>
#include<cmath>
#include<deque>
#include<vector>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
using namespace std;

typedef long long ll;
const int inf = 0x3f3f3f3f;
const int M = 1e7 + 100;
ll a[M];
struct node
{
    ll x;
    int id;
}num[M];
int t;
ll n,m,k,p,q,r,mod;
int main()
{
    scanf("%d",&t);
    while(t--)
    {
        scanf("%lld%lld%lld%lld%lld%lld%lld",&n,&m,&k,&p,&q,&r,&mod);
        for(int i=1;i<=k;i++)
        {
            scanf("%lld",&a[i]);
        }
        for(int i=k+1;i<=n;i++)
            a[i]=((p*a[i-1])%mod+(q*i)%mod+r)%mod;
       int l=0,r=0,i;
       ll k=n-m+1;
       ll mac=0,cnt=0;
       for( i=n;i>n-m;i--)
       {
           if(l==r)
           {
               num[r].x=a[i];
               num[r++].id=i;
           }else
           if(a[i]<num[r-1].x){
            num[r].x=a[i];
            num[r++].id=i;
           }else
           if(a[i]==num[r-1].x)
           {
               num[r-1].id=i;
           }
           else{
            while(num[r-1].x<a[i]&&r>l){
                   r--;
            }
            num[r].x=a[i];
            num[r++].id=i;
           }
       }//cout<<l<<" "<<r<<endl;
       mac+=num[l].x^k;
       cnt+=(r-l)^k;
       //cout<<k<<" "<<num[l].x<<" "<<res<<endl;
       for(;i>=1;i--)
       {
           k--;
           if(num[l].id>=i+m&&l<r)
           {
               l++;
           }
           if(l==r)
           {
               num[r].x=a[i];
               num[r++].id=i;
           }else
           if(a[i]<num[r-1].x){
            num[r].x=a[i];
            num[r++].id=i;
           }else
           if(a[i]==num[r-1].x)
           {
               num[r-1].id=i;
           }
           else{
            while(num[r-1].x<a[i]&&r>l){
                   r--;
            }
            num[r].x=a[i];
            num[r++].id=i;
           }//cout<<l<<" "<<r<<endl;
           mac+=num[l].x^k;
           cnt+=(r-l)^k;
           //cout<<k<<" "<<num[l].x<<" "<<(r-l)<<endl;
       }
       printf("%lld %lld\n",mac,cnt);
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/liluoyu_1016/article/details/81316832
今日推荐